---
title: IdleDeadline
slug: Web/API/IdleDeadline
tags:
  - API
  - Background Tasks API
  - IdleDeadline
  - Interface
  - Reference
  - requestIdleCallback
---
<div>{{APIRef("Background Tasks")}}</div>

<div id="interface_description">
<p>The <code>IdleDeadline</code> interface is used as the data type of the input parameter to idle callbacks established by calling {{domxref("Window.requestIdleCallback()")}}. It offers a method, {{domxref("IdleDeadline.timeRemaining", "timeRemaining()")}}, which lets you determine how much longer the user agent estimates it will remain idle and a property, {{domxref("IdleDeadline.didTimeout", "didTimeout")}}, which lets you determine if your callback is executing because its timeout duration expired.</p>

<p>To learn more about how request callbacks work, see <a href="/en-US/docs/Web/API/Background_Tasks_API">Collaborative Scheduling of Background Tasks</a>.</p>
</div>

<h2 id="Properties">Properties</h2>

<dl id="property_definitions">
 <dt>{{domxref("IdleDeadline.didTimeout")}} {{ReadOnlyInline}}</dt>
 <dd>A Boolean whose value is <code>true</code> if the callback is being executed because the timeout specified when the idle callback was installed has expired.</dd>
</dl>

<h2 id="methods">Methods</h2>

<dl id="method_definitions">
 <dt>{{domxref("IdleDeadline.timeRemaining()")}}</dt>
 <dd>Returns a {{domxref("DOMHighResTimeStamp")}}, which is a floating-point value providing an estimate of the number of milliseconds remaining in the current idle period. If the idle period is over, the value is 0. Your callback can call this repeatedly to see if there's enough time left to do more work before returning.</dd>
</dl>

<dl id="method_definitions_obsolete">
</dl>

<h2 id="Example">Example</h2>

<p>See our <a href="/en-US/docs/Web/API/Background_Tasks_API#Example">complete example</a> in the article <a href="/en-US/docs/Web/API/Background_Tasks_API">Cooperative Scheduling of Background Tasks API</a>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("Background Tasks")}}</td>
   <td>{{Spec2("Background Tasks")}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.IdleDeadline")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Background_Tasks_API">Cooperative Scheduling of Background Tasks API</a></li>
 <li>{{domxref("Window.requestIdleCallback()")}}</li>
 <li>{{domxref("Window.cancelIdleCallback()")}}</li>
</ul>
